function v = parse_number(str)
%  PARSE_NUMBER
%  converts string to number, recognizing standard power suffixes
%     v = parse_number(str)
%     str = string to be converted
%     v = numeric result
%

offset = find(~isletter(str),1,'last');
num = str(1:offset);
v = str2double(num);
n = length(str);
if (offset<n)
    switch (str(offset+1))
        case 'f'
            v = v*1e-15;
        case 'p'
            v = v*1e-12;
        case 'n'
            v = v*1e-9;
        case 'u'
            v = v*1e-6;
        case 'm'
            v = v*1e-3;
        case {'k','K'}
            v = v*1e3;
        case 'M'
            v = v*1e6;
        case 'G'
            v = v*1e9;
        case 'T'
            v = v*1e12;
    end
end
%fprintf('%s = %g\n',str,v);