% count the number of nodes
nbr_nodes = length(nodenames);

% count the number of voltage sources
idv = find(strcmp(Type,'V'))';
idl = find(strcmp(Type,'L'))';
ide = find(strcmp(Type,'E'))';
idf = find(strcmp(Type,'F'))';
idoa = find(strcmp(Type,'OA'))';
nrows = nbr_nodes + length(idv) + length(idl)+ length(ide) + length(idf) + length(idoa);

Gm = zeros(nrows);
Cm = zeros(nrows);
clear k;

% name the voltage nodes
yname = cell(nbr_nodes,1);
for k = 1:nbr_nodes
    yname(k) = cellstr(sprintf('V(%s)',char(nodenames(k))));
end


%Resistances
idr = find(strcmp(Type,'R'))';

% Remember: for a for loop the index is set to the columns of idr,
% so here idr must be a row vector.
for k = idr
    Node = comp(k).node;
    Gm = nmAcc(Node(1),Node(2),1/comp(k).value,Gm);
end

%Capacitance
idc = find(strcmp(Type,'C'))';
for k = idc
    Node = comp(k).node;
    Cm = nmAcc(Node(1),Node(2),comp(k).value,Cm);
end

% G Source (VCCS)
idg = find(strcmp(Type,'G'))';

for k=idg
    Node = comp(k).node;
    Gm = gmAcc(Node(1),Node(2),Node(3),Node(4),comp(k).value,Gm);
end

% General current sources
idi = find(strcmp(Type,'I'))';

Is  = zeros(nrows,1);
for k = idi
    Node = comp(k).node;
    Is=srcAcc(Node(1),Node(2),comp(k).value,Is);
end

% General voltage sources
m = nbr_nodes;
for k = idv
    m = m + 1;
    Node = comp(k).node;
    Gm = mnaVsrc(m,Node(1),Node(2),Gm);
    Is(m) = comp(k).value; % ??? Check on this
    % name the current node
    %str1 = char(nodenames(Node(1)));
    %str2 = char(nodenames(Node(2)));
    yname(m)=cellstr(sprintf('I(%s)',comp(k).name));
end

% Inductor
for k = idl
    m = m + 1;
    Node = comp(k).node;
    Gm = mnaVsrc(m,Node(1),Node(2),Gm);
    Cm(m,m) = -comp(k).value;
end


% E Source (VCVS)
for k = ide
    m = m+1;
    Node = comp(k).node;
    Gm = mnaEsrc(m,Node(1),Node(2),Node(3),Node(4),comp(k).value,Gm);
end

% F Source (CCVS)
for k = idf
    m = m+1;
    Node = comp(k).node;
    Gm = mnaFsrc(m,Node(1),Node(2),Node(3),Node(4),comp(k).value,Gm);
end

% OA Source (ideal op-amp)
% Node(1) and Node(2) are the noninverting and the inverting op-amp
% input nodes. Node(3) is the output node
for k = idoa
    m = m+1;
    Node = comp(k).node;
    Gm = mnaOA(m,Node(1),Node(2),Node(3),Gm);
    %str1 = char(nodenames(Node(3)));
    yname(m) = cellstr(sprintf('I(%s)',comp(k).name));
end
%%
% clear temporary variables
clear k m n;
clear Node nrows nbr_nodes str1;
clear idc ide idf idg idi idl idoa idr idv;

%y=Gm\Is;
